package ho.tests.thread.synchro.test1.order2.semaphore;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Semaphore;

/**
 * Thread launching example using semaphore synchronization
 * @author Huseyin OZVEREN
 */
public class ApplicationSemaphore {
	public static void main(String[] args) {
		ExecutorService es = Executors.newFixedThreadPool(2);
		// SEMPAHORE
		// Param1=current value of the semaphore that defines the number of resources available initially (when is 0 then lock)
		// Param2=boolean indicating whether the method of administration must be FIFO
		Semaphore personalSem = new Semaphore(1, true);
		Semaphore neighboringSem = new Semaphore(0, true);

		System.out.println( "Starting threads in main thread" );

		// create and name each runnable
		// 1st thread
		MyTask th1 = new MyTask("threadname_1", personalSem, neighboringSem);
		es.execute(th1);

		// 2nd thread
		MyTask th2 = new MyTask("threadname_2", neighboringSem, personalSem);
		es.execute(th2);

		// shutdown worker threads  
		es.shutdown();

		System.out.println( "Threads started, main thread ends\n" );
	}
}
