package ho.tests.thread.synchro.test1.order2.semaphore;

import java.util.Random;
import java.util.concurrent.Semaphore;

/**
 * Mytask Runnable example using semaphore synchronization
 * @author Huseyin OZVEREN
 */
public class MyTask implements Runnable {
	
	private int sleepTime; // random sleep time for thread   
	private String threadName; // name of thread   
	private static Random generator = new Random();
	
	Semaphore personalSem;
	Semaphore neighboringSem;

	public MyTask(String name, Semaphore personalSem, Semaphore neighboringSem) {
		// set name of thread
		this.threadName = name;
		// random sleep time between 0 and 5 seconds
		this.sleepTime = generator.nextInt( 5000 ); 
		//
		this.personalSem = personalSem;
		this.neighboringSem = neighboringSem;
	}

	public void run() {
		try {
			personalSem.acquire();
		} catch (InterruptedException ex) {
			System.out.println(ex);
		}

		try{ 
			// put thread to sleep for sleepTime amount of time
			System.out.printf( "%s starting and going to sleep for %d milliseconds.\n", this.threadName, this.sleepTime );
			// put thread to sleep
			Thread.sleep( this.sleepTime );   
		} catch ( InterruptedException exception )  {  
			exception.printStackTrace(); 
		}
		
		// print thread name
		System.out.printf( "%s done sleeping\n", this.threadName ); 
		
		// release semaphore => unblock the next task
		neighboringSem.release();
	}
}