package ho.tests.thread.synchro.test1.order4.mutex;


import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.locks.ReentrantLock;

/**
 * Thread launching example using mutex and barrier synchronization
 * @author Huseyin OZVEREN
 */
public class ApplicationBarrierMutex {
	
	// Variable which could be modified by several tasks = "critical resource"
	public static String objToProtectSynchro = "";
	
	public static void main(String[] args) {
		ExecutorService es = Executors.newFixedThreadPool(2);
		//MUTEX:
		// Param1=bboolean indicating whether the method of administration must be FIFO on this lock.
		ReentrantLock mutex = new ReentrantLock(true);
		
		// BARRIER for 2 threads
		// Param1=blocking counter initialized with an integer value
		CountDownLatch barrier = new CountDownLatch(2);
		
		System.out.println( "Starting threads in main thread" );

		
		// create and name each runnable
		// 1st thread
		MyTask th1 = new MyTask("threadname_1", mutex, barrier);
		es.execute(th1);

		// 2nd thread
		MyTask th2 = new MyTask("threadname_2", mutex, barrier);
		es.execute(th2);
		
		try {
			barrier.await(); // Current thread is blocked until all others threads have call the method bar.countDown();
		} catch (InterruptedException ex) {
			System.out.println(ex);
		}

		// shutdown worker threads  
		es.shutdown();

		System.out.println( "Threads started, main thread ends\n" );
	}
}
